#````````````````````````````
#  fR[h
#````````````````````````````
sub decode {
	&ReadParse;

	foreach (keys %in) {
		if ($_ ne 'img') {
			$in{$_} =~ tr/+/ /;
			$in{$_} =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

			$in{'len1'} = $in{$_} if ($_ eq 'outline');
			$in{'len2'} = $in{$_} if ($_ eq 'text');
			$in{'len3'} = $in{$_} if ($_ eq 'message');

			$in{$_} =~ s/&/&amp;/g;
			$in{$_} =~ s/"/&quot;/g;
			$in{$_} =~ s/'/&#39;/g;
			$in{$_} =~ s/\//&#47;/g;
			$in{$_} =~ s/\./&#046;/g;
			$in{$_} =~ s/</&lt;/g;
			$in{$_} =~ s/>/&gt;/g;
			$in{$_} =~ s/\t/  /g;
			$in{$_} =~ s/\0//g;
			$in{$_} =~ s/\r\n|\r|\n/<br>/g;

			# ^O
			if (!$notag and ($_ eq 'text' || $_ eq 'outline' || $_ eq 'message')) {
				my $tag = join ('|', @oktag);
				$in{$_} =~ s/&lt;(\/?($tag).*?)&gt;/<$1>/ig;
			}

			&jcode::convert(\$in{$_},'sjis');
		}
	}

	return %in;
}

#````````````````````````````
#  zXgl
#````````````````````````````
sub get_host {
	my ($addr, $host) = ($ENV{'REMOTE_ADDR'}, $ENV{'REMOTE_HOST'});

	if ($host eq $addr || !$host) {
		$host = gethostbyaddr(pack("C4", split(/\./,$addr)), 2) || $addr;
	}

	return $host;
}

#==============================================
#  ANZX`FbN
#==============================================
sub access_check {
	if (($refurl && (!$ENV{'HTTP_REFERER'} or $ENV{'HTTP_REFERER'} !~ /^$refurl/)) || (!$mobile and $ENV{'REQUEST_METHOD'} ne 'POST')) {
		&error("sȃANZXłB");
	}
	if ($endeny && $ENV{'HTTP_ACCEPT_LANGUAGE'} !~ /^(ja)/i) {
		&error('ERROR!');
	}
}

#````````````````````````````
#  ANZX
#````````````````````````````
sub deny {
	my $denyflg;
	for (my $i = 0; $i < ((@deny)+(@deny2)); $i++) {
		# IPzXg
		if ($deny[$i]) {
			$deny[$i] =~ s/\./\\./g; $deny[$i] =~ s/\*/\.\*/g;
			if ($host =~ /$deny[$i]/i) { $denyflg = 1; last; }
		}

		# Cookie
		if ($deny2[$i]) {
			if ($COOKIE{'name'} eq $deny2[$i]) { $denyflg = 1; last; }
		}
	}

	if ($denyflg) {
		&error($denyms);
	}
}

#==============================================
#  NbL[o
#==============================================
sub set_cookie {
	my ($mode, $value, $value2) = @_;
	my (@mons, @week, $date, $cook);
	my ($sec, $min, $hour, $mday, $mon, $year, $wday) = gmtime(time + 365*24*60*60);

	@mons = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
	@week = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
	$date = sprintf("%s, %02d\-%s\-%04d %02d:%02d:%02d GMT",
						$week[$wday], $mday, $mons[$mon], $year+1900, $hour, $min, $sec);

	if ($mode == 1) {
		# e
		print "Set-Cookie: MTSS1=pass\:$value\,pname\:$value2; expires=$date\n";
	} elsif ($mode == 2) {
		# ze
		print "Set-Cookie: MTSS2=name\:$value; expires=$date\n";
	}
}

#==============================================
#  NbL[ǂݏo
#==============================================
sub get_cookie {
	my ($name, $value, @pairs, %DUMMY, %COOKIE);

	@pairs = split(/\;/, $ENV{'HTTP_COOKIE'});

	foreach (@pairs) {
		($name, $value) = split(/\=/, $_);
		$name =~ s/ //g;
		$DUMMY{$name} = $value;
	}

	@pairs = split(/\,/, "$DUMMY{'MTSS1'},$DUMMY{'MTSS2'}");

	foreach (@pairs) {
		($name, $value) = split(/\:/, $_);
		$COOKIE{$name} = $value;
	}

	return %COOKIE;
}

#````````````````````````````
#  bN
#````````````````````````````
sub lock {
	# 3ȏÂbN͉
	if (-e $lockdir) {
		my $mtime = (stat($lockdir))[9];
		if ($mtime < time - 60*3) { &unlock; }
	}

	my $retry = 5;

	while (!mkdir($lockdir, 0755)) {
		if (--$retry <= 0) {
			&error('rW[ԂłB΂炭҂ĂēxMĂB');
		}
		sleep(1);
	}

	$lockflg = 1;
}

#````````````````````````````
#  bN
#````````````````````````````
sub unlock {
	rmdir($lockdir);
	$lockflg = 0;
}

#````````````````````````````
#  t@Cǂݍ
#````````````````````````````
sub file_read {
	my ($file) = @_;

	open (FILE, "$file") || &error("t@C\"$file\"J܂łB");
		flock (FILE, 1) if ($lock == 1 && $oplock);
		my @line = <FILE>;
	close (FILE);

	chomp (@line);

	return @line;
}

#````````````````````````````
#  t@C
#````````````````````````````
sub file_write {
	my ($file, @data) = @_;

	open (FILE, "+< $file") || &error("t@C\"$file\"J܂łB");
	flock (FILE, 2) if ($lock == 1);
	seek (FILE, 0, 0) if ($lock == 1);
	foreach (@data) {
		print FILE "$_\n";
	}
	truncate (FILE, tell (FILE)) if ($lock == 1);
	close (FILE);
}

#````````````````````````````
#  t@C݁iVK쐬j
#````````````````````````````
sub new_file_write {
	my ($file, @data) = @_;

	open (FILE, ">$file") || &error("t@C\"$file\"J܂łB");
		foreach (@data) {
			print FILE "$_\n";
		}
	close (FILE);
}

#````````````````````````````
#  摜Abv[h
#````````````````````````````
sub img_write {
	my ($name, $file, $img) = @_;

	my $okimg =  join ('|', @okimg);

	# ̉摜폜
	unlink <$name\.*>;

	my $ext;
    if ($file =~ /(.+\.($okimg))$/) {
	    open (IMG,">$name.$2");
	    binmode IMG;
	    print IMG $img;
	    close (IMG);

		$ext = $2; # gq
	} else {
		&error("Ή̊gqłB");
	}

	return $ext;
}

# 摜TCY
sub img_size {
	my ($wid, $hei) = @_;

	if ($wid > $imgwid || $hei > $imghei) {
		if ($oversz) {
			# 摜TCYK蒴ĂΒ
			$wid = $imgwid if ($wid > $imgwid);
			$hei = $imghei if ($hei > $imghei);
		} else {
			&error("}G̃TCY傫܂B");
		}
	}

	return ($wid, $hei);
}

#````````````````````````````
#  vr[
#````````````````````````````
sub preview {
	if ($incfn{'img'}) {
		# V摜
		if ($incfn{'img'} !~ /.+:\\.\..+/) {
			# [JpX擾oȂꍇ
			$FORM{'text'} =~ s/##img##/<img alt="ɉ摜}܂B" align="$FORM{'align'}">/g;
		} else {
			# u
			$FORM{'text'} =~ s/##img##/<img src="$incfn{'img'}" alt="摜">/g;
		}
	} elsif (-e <$imgdir$FORM{'log'}_$FORM{'no'}.*>) {
		# ̉摜Ε\
		foreach (@okimg) {
			if (-e "$imgdir$FORM{'log'}_$FORM{'no'}.$_") {
				my ($wid, $hei) = &img_size((&GetImageSize("$imgdir$FORM{'log'}_$FORM{'no'}.$_"))[1, 2]);
				$FORM{'text'} =~ s/##img##/<img src="$imgdir$FORM{'log'}_$FORM{'no'}.$_" width="$wid" height="$hei" alt="摜">/g;
			}
		}
	}

	my $divwid = $winw - 100;

	&header("vr[");

	print qq(
	<div class="top" style="width: $divwid;">
	<div class="cell">
	<div class="work">
	$FORM{'text'}
	</div>
	</div>
	</div>
	<p align="center"><button onclick="window.close();"></button></p>
	</center>
	</body></html>
	);
}

#````````````````````````````
#  javascript
#````````````````````````````
sub java {
	print <<"_JAVA_";
<script language="javascript">
<!--

function trview(no) {
	if (document.getElementById('rs'+no).style.display == "") {
		document.getElementById('rs'+no).style.display = "none";
		document.getElementById('mt'+no).className = "botm";
	} else if (document.getElementById('rs'+no).style.display == "none") {
		document.getElementById('rs'+no).style.display = "";
		document.getElementById('mt'+no).className = "botm_das";
	}
}

function disview(disid) {
	if (document.getElementById(disid).style.display == "") {
		document.getElementById(disid).style.display = "none";
	} else if (document.getElementById(disid).style.display == "none") {
		document.getElementById(disid).style.display = "";
	}
}

function txtrsize(ud) {
	if (ud == 1) {
		document.form.text.rows += 5;
	} else {
		document.form.text.rows -= 5;
	}
}

function check() {
	var txt = document.form.text.value;
	txt = txt.replace(/\\r\\n/g, "");
	txt = txt.replace(/\\n/g, "");
	txt = txt.replace(/##img##/g, "");
	txt = txt.replace(/<.+?>/g, "");
	var len = txt.length;
	if (($maxtext && len > $maxtext) || ($mintext && len < $mintext)) {
		len = "<font color=\\"#CC3333\\">"+len+"</font>";
	}
	document.getElementById('cnt').innerHTML = len;
}

function preview(mode) {
	document.form.target = "win";
	document.form.mode.value = "preview";
	x = (screen.width - $winw) / 2;
	y = (screen.height - $winh) / 2;
	win = window.open("about:blank","win","width=$winw,height=$winh,scrollbars=yes,status=no,directories=no,menubar=no,resizable=yes,toolbar=no");
	window.win.moveTo(x, y);
	document.form.submit();
	document.form.mode.value = mode;
	document.form.target = "";
}

// -->
</script>
_JAVA_
}

#````````````````````````````
# wb_[
#````````````````````````````
sub header {
	my ($title, $java) = @_;

	$title .= ' | ' if ($title);

	if (!$mobile) {
		print "Content-type: text/html\n\n";
		print qq(
		<html>
		<head>
		<meta http-equiv="Content-type" content="text/html; charset=shift_jis">);
		print qq(<link rel="alternate" type="application/rss+xml" title="RSS" href="$script?mode=rss">) if ($userss);
		print qq(<link rel="stylesheet" type="text/css" href="$style">
		<title>$title$cgititle</title>
		);

		&java if ($java);

		print qq(
		</head>
		<body>
		<center>
		);
	} else {
		print "Content-type: application/xhtml+xml\n\n";
		print qq(<?xml version="1.0" encoding="shift_jis"?>
		<!DOCTYPE html PUBLIC "-//WAPFORUM//DTD XHTML Mobile 1.0//EN" "http://www.wapforum.org/DTD/xhtml-mobile10.dtd">
		<html xmlns="http://www.w3.org/1999/xhtml" lang="ja" xml:lang="ja">
		<head>
		<meta http-equiv="Content-type" content="application/xhtml+xml; charset=shift_jis" />
		<title>$title$cgititle</title>
		</head>
		<body$mobile_body>
		<div style="font-size: 13px; padding: 3px;">
		);
	}
}

#````````````````````````````
# tb^[
#````````````````````````````
sub footer {

	print (($mobile) ? qq(<hr /></div>) : qq(</center>));

	print <<"_HTML_";
<div align="right">
<span style="font-size: 10px;"><a href="http://goo.gl/kxtdN">܂₩e܁[ Ver$version</a></span>
</div>
</body>
</html>
_HTML_
}

#````````````````````````````
#  tl
#````````````````````````````
sub get_days{
	my ($sec, $min, $hour, $day, $mon, $year, $wday, $yday, $isdst) = gmtime($_[0]+60*60*9);
	return sprintf("%04d/%02d/%02d %02d:%02d", $year+1900, $mon+1, $day, $hour, $min);
}

#````````````````````````````
#  pX[hÍ
#````````````````````````````
sub encrypt {
	my ($pass) = @_;

	my $xx = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
	      . "abcdefghijklmnopqrstuvwxyz"
                 . "0123456789./";
	my $salt = substr($xx, int(rand(64)), 1);
	$salt .= substr($xx, int(rand(64)), 1);
	my $pwd = crypt($pass, $salt);

	return $pwd;
}

#````````````````````````````
#  F؊mF
#````````````````````````````
sub pass_check {
	my ($pass, $pwd) = @_;

	my $salt = substr($pwd,0,2);

	if (!$pass) {
		&error("pX[h͂Ă܂B");
	} elsif (!$pwd) {
		&error("pX[h͓o^Ă܂B");
	} elsif ($pwd ne crypt($pass, $salt) && $pass ne $mskey) {
		&error("pX[hԈĂ܂B");
	}
}

#````````````````````````````
#  G[
#````````````````````````````
sub error {
	&error_mobile(@_) if ($mobile);

	&header('error');

	print qq(<p><table cellpadding="10"><tr><td><font color="#CC3333">G[</font><br>);

	foreach (@_) {
		print qq(<font color="#CC3333">&gt;&nbsp;</font>$_<br>);
	}

	print qq(
	</tr></td></table></p>
	<a href="JavaScript:history.back()">߂</a>
	</center>
	</body></html>
	);

	exit;
}

#````````````````````````````
#  G[igсj
#````````````````````````````
sub error_mobile {
	&unlock if ($lockflg);

	&header('error');

	print qq(
	<div align="left">
	<span style="color: #CC3333;">G[<br />
	);
	foreach (@_) {
		print qq(&gt;&nbsp;$_<br />);
	}
	print qq(
	</span>
	<hr />
	u߂v{^Ŗ߂ĂB
	<hr />
	<a href="$script?">TOP</a>
	</div>
	</div>
	</body></html>
	);

	exit;
}

1